      SUBROUTINE  OUTPUT(No_Rows)

*/ Here we finally get around to printing out the variables.

      integer*1 I_Header, I_Columns
      integer No_Rows


      INCLUDE 'modvars.h'


*/ Write the Header Information

      Data I_Header, Undefined / 1, 0.0 /

      G_Flux = Rnet - Heat - Evap
      Bowen = Heat/Evap
      If (Bowen .lt. 0.0) Bowen = undefined

      If (FRVEG .ne. 0.0) then
	air_leaf_T = TAF - 273.15
*/ground_T = TG - 273.15
      else
	air_leaf_T = undefined
*/ground_T = undefined
	vfl = undefined
      endif


      PES = ( XLAI / 2.0 ) + 1
      Stom_R = RS * PES / XLAI
      co2_flux = fco2*1e6
      ccan_concn = ccan*1e6
      Water_Use_Eff = (co2_flux*4.4e-8)/(xlef/le)


      if (I_Header .eq. 1) then

	I_Columns = 30
C	write (11, 4) I_Columns, No_Rows
C 4	format(4(I4,1X))

        WRITE (11,*) 'TIME: Local time (hours)'
        WRITE (11,*) 'SWF: Shortwave_Flux (W m-2)'
        WRITE (11,*) 'NETRAD: Net_Radiation (W m-2)'
        WRITE (11,*) 'SENS: Sensible_Heat_Flux (W m-2)'
        WRITE (11,*) 'LE: Latent_Heat_Flux (W m-2)'
        WRITE (11,*) 'GRF: Ground_Flux (W m-2)'
        WRITE (11,*) 'T50: Air_Temperature_50m (C)'
        WRITE (11,*) 'T10: Air_Temperature_10m (C)'
        WRITE (11,*) 'TFOL: Air_Temperature_Foliage (C)'
        WRITE (11,*) 'TRAD: Radiometric_Temperature (C)'
        WRITE (11,*) 'W50: Wind_50_Meters (Kts)'
        WRITE (11,*) 'W10: Wind_10_Meters (Kts)'
        WRITE (11,*) 'WFOL: Wind_In_Foliage (Kts)'
        WRITE (11,*) 'SH50: Specific_Humidity_50m (g Kg-1)'
        WRITE (11,*) 'SH10: Specific_Humidity_10m (g Kg-1)'
        WRITE (11,*) 'SHFOL: Specific_Humidity_In_Foliage (g Kg-1)'
        WRITE (11,*) 'BOW: Bowen_Ratio'
        WRITE (11,*) 'SMA: Surface_Moisture_Availability'
        WRITE (11,*) 'RZMA: Root_Zone_Moisture_Availability'
        WRITE (11,*) 'STMR: Stomatal_Resistance (s m-1)'
        WRITE (11,*) 'VPDEF: Vapour_Pressure_Deficit (mbar)'
        WRITE (11,*) 'LWPOT: Leaf_Water_Potential (bars)'
        WRITE (11,*) 'EWPOT: Epidermal_Water_Potential (bars)'
        WRITE (11,*) 'GWPOT: Ground_Water_Potential (bars)'
        WRITE (11,*) 'CO2F: CO2_Flux (micromoles m-2 s-1)'
        WRITE (11,*) 'CO2CAN: CO2_Concentration_Canopy (ppmv)'
        WRITE (11,*) 'WATEFF: Water_Use_Efficiency'
        WRITE (11,*) 'O3CAN: O3_conc_canopy (ppmv)'
        WRITE (11,*) 'GBLO3: Global_O3_flux (ug m-2 s-1)'
        WRITE (11,*) 'O3F: O3_flux_plant (ug m-2 s-1)'

        WRITE (11,9)
9       FORMAT(/' TIME    SWF   NETRAD    SENS    LE      GRF',
     &    '    T50   T10',
     &    '   TFOL TRAD',
     &    '   W50   W10   WFOL  SH50  SH10 SHFOL ',
     &    '    BOW   SMA  RZMA',
     &    '    STMR  VPDEF  LWPOT EWPOT   GWPOT     CO2F ',
     &    ' CO2CAN',
     &    '    WATEFF   O3CAN  GBLO3   O3F'/)

	I_Header = 2

      endif

C      WRITE (17,29) PTIME,Stom_R,RMIN,RS,PES,XLAI
C29    FORMAT(F5.2,X,F6.1,F6.1,F6.1,G9.3E1,F6.1)

*/ Default data file (Primy.dat)

       IF (RNET .LE. 0 .OR. SWAVE .LE. 0) THEN

*/ Night
*/ No Vegetation Response


	 WRITE (11,10) PTIME,SWAVE,RNET,HEAT,EVAP,G_Flux,
     /	      atemp-273.15,ta-273.15,air_leaf_T,OTEMP-273.15,
     /	      awind*1.98, uten*1.98, uaf*1.98,
     /	      Q_Fine(1)*1000, QA*1000, QAF*1000,
     /	      Bowen, F, FSUB, Stom_R, vfl, psim, psie, psig,
     /        co2_flux, ccan_concn, Water_Use_Eff,caf,fglobal,
     /        flux_plant
       ELSE

*/ Day

       If (heat .gt. 0) then

	 WRITE (11,10) PTIME,SWAVE,RNET,HEAT,EVAP,G_Flux,
     /	      atemp-273.15,ta-273.15,air_leaf_T,OTEMP-273.15,
     /	      awind*1.98, uten*1.98, uaf*1.98,
     /	      Q_Fine(1)*1000, QA*1000, QAF*1000,
     /	      Bowen, F, FSUB, Stom_R, vfl, psim, psie, psig,
     /	      co2_flux, ccan_concn, Water_Use_Eff,caf,fglobal,
     /	      flux_plant
       else

	 WRITE (11,10) PTIME,SWAVE,RNET,HEAT,EVAP,G_Flux,
     /	      atemp-273.15,ta-273.15,air_leaf_T,OTEMP-273.15,
     /	      awind*1.98, uten*1.98, uaf*1.98,
     /	      Q_Fine(1)*1000, QA*1000, QAF*1000,
     /	      Bowen, F, FSUB, Stom_R, vfl, psim, psie, psig,
     /	      co2_flux, ccan_concn, Water_Use_Eff,caf,fglobal,
     /	      flux_plant
       endif

      END IF

  10  FORMAT (F5.2,1x,5(F7.2,1X),1x,10(F5.2,1x)
     /        ,1x,F7.3,1x,F5.3,1X,F5.3,1X,F6.1,1x,F5.2,1x,2(F6.2,1x),
     /        G9.3E1,1x,F7.3,1x,F6.2,2X,G9.3E1,1X,3(F6.3,1x))


      RETURN
      END
