	SUBROUTINE  START (Obst_Hgt,dual_regime,zo_patch)

	Real*4 Obst_Hgt, zo_patch
	logical  zo_flag, ob_flag, dual_regime

	Character*1  ALBEDO_GFLAG, ALBEDO_FFLAG ! For Interface
	Character*15  soiltype
	Character*30  planttype
	Integer*1 num_soils, num_of_veggies, index_soils, index_veggies

      INCLUDE 'modvars.h'

	zo_flag = .false.
	ob_flag = .false.
*/	Class = 'U'

C **  This subroutine reads in the control variables from the input
C **  file.

	OPEN ( UNIT=9, FILE = 'i_model.dat' ) ! Open file for input
					      ! Closed in Snding.for
c     ^^^^------------------- it should have been, but it wasn't.

C **  Read stuff for main program.


      READ (9,*) IYR, IMO, IDAY, TZ, XLAT, XLONG, STRTIM, TIMEND,
     /		 OUTTT, SLOPE, ASPECT
C
C     Echo the input controls in the output
      WRITE (11,'(/A/)') '         ***  INPUT PARAMETERS  ***'
      WRITE (11,151) 'Year, Month, Day (IYR, IMO, IDAY): ',
     &  IYR, IMO, IDAY,
     &  'Time Zone (TZ): ',TZ,
     &  'Lat/Long (XLAT,XLONG): ',XLAT, XLONG,
     &  'Start/End Time (STRTIM, TIMEND): ',STRTIM, TIMEND,
     &  'Output Time Interval (OUTTT): ',OUTTT,
     &  'Slope and Aspect: ', SLOPE, ASPECT
151   FORMAT (A,I5,I3,I3,/,
     &  A,F6.2,/,
     &  A,F8.3,',',F8.3,/,
     &  A,F6.2,F8.2,/,
     &  A,F6.0,/,
     &  A,2F6.1)
C

	READ (9,*) F, FSUB, WMAX, BTEMP, TP, DUAL_TI, TI_A, TI_B,
     /         ALBEDO_GFLAG, ALBG, EPSI, index_soils
C
C     Echo the input controls in the output
      WRITE (11,152) 'Moisture Availability (F): ', F,
     &  'Root Zone Moisture Availability (FSUB): ', FSUB
152   FORMAT(A,F5.2,/,A,F5.2)
      WRITE (11,153) 'Substrate Maximum Water (WMAX): ', WMAX,
     &  'Lowest Soil Level Temperature (BTEMP): ', BTEMP
153   FORMAT(A,F5.2,/,A,F7.2)
      WRITE (11,154) 'Thermal Inertia (TP): ', TP,
     &  'Dual Thermal Inertia Flag and Values (DUAL_TI, TI_A, TI_B): ',
     &    DUAL_TI, TI_A, TI_B,
     &  'Ground Albedo Flag (ALBEDO_GFLAG): ', ALBEDO_GFLAG,
     &  'Ground Albedo (ALBG): ', ALBG,
     &  'Emissivity (EPSI): ', EPSI,
     &  'Soil Type Index Number (index_soils): ', index_soils
154   FORMAT(A,F5.2,/,A,X,A,X,F7.2,F7.2,
     &  /,A,X,A,/,A,F7.2,
     &  /,A,F7.2,/,A,I3)

	cloud_flag=(1.eq.1)

	READ (9,*) OMEGA, ZO, OBST_HGT, cloud_flag, cld_fract

      WRITE (11,155) OMEGA, ZO, OBST_HGT, cloud_flag, cld_fract
155   FORMAT('Precipitable Water Content (OMEGA): ',F5.2,
     &  /,'Roughness Height (ZO): ',F7.2,
     &  /,'Obstructions Height (OBST_HGT): ',F7.2,/,
     &  'Clouds Flag (CLOUD_FLAG): ',L2,
     &  /,'Cloud Fraction (CLOUD_FRACT): ',I3)

      READ (9,*) FRVEG, XLAI, EPSF, ALBEDO_FFLAG, ALBF, STMTYPE,
     /		 index_veggies, VOLREL, rmin, rcut, WILT, VEGHEIGHT,
     /		 WIDTH, STEADY, CI, CO , coz_sfc, coz_air

      WRITE (11,156) FRVEG, XLAI, ALBEDO_FFLAG, EPSF, ALBF, STMTYPE,
     &  index_veggies, VOLREL, rmin, rcut, WILT, VEGHEIGHT,
     &  WIDTH, STEADY, CI, CO , coz_sfc, coz_air
156   FORMAT('Vegetation Percent (FRVEG): ',F5.2,/,
     &  'Leaf Area Index (XLAI): ',F7.2,/,
     &  'Foliage Emissivity Flag (ALBEDO_FFLAG): ',A,/,
     &  'Foliage Emissivity (EPSF): ',F7.2,/,
     &  'Foliage Albedo (ALBF): ',F7.2,/,
     &  'Stomatal Resistance Scheme (STMTYPE): ',A,/,
     &  'Plant Type (index_veggies): ',I3,/,
     &  'Relative Water Volume (VOLREL): ',F7.2,/,
     &  'Bulk Stomatal Resistance (RMIN): ',F7.2,/,
     &  'Cuticular Resistance (RCUT): ',F7.2,/,
     &  'Wilting Point (WILT): ',F7.2,/,
     &  'Vegetation Height (VEGHEIGHT, STMTYPE=L): ',F7.2,/,
     &  'Leaf Width (WIDTH, STMTYPE=L): ',F7.2,/,
     &  'Capacitance Flag (STEADY, STMTYPE=L): ',A,/,
     &  'Internal CO2 Concentration (CI): ',F7.2,/,
     &  'External CO2 Concentration (CO): ',F7.2,/,
     &  'Surface Ozone Concentration (COZ_SFC): ',F7.2,/,
     &  'Ambient Ozone Concentration (COZ_AIR): ',F7.2)

*/ Include the vegetation and soils databases in the calculations.
*/

      if(xlai .eq. 0.0) xlai = 1.0
      xlef = 1

      If (FRVEG .gt. 0.0 .and. stmtype .eq. 'L') then

	open (1, file = 'soils.dat') ! Begin with opening the file

	Read (1, *) num_soils	     ! Required for Interface

	Do 10 i = 1, index_soils
	 Read (1,*) soiltype, rks, cosbyb, thmax, psis ! Read
  10	continue

	close (unit = 1)

      WRITE(11,166) soiltype, rks, cosbyb, thmax, psis
166   FORMAT(//'   ***  Soil LUT Data Used for this run  ***'//
     &  'Soiltype: 'A/
     &  'RKS: ',F6.1/
     &  'CosbyB: ',F6.1/
     &  'THMAX: ',F6.1/
     &  'PSIS: ',F6.1)

	open (1, file = 'veglut.dat') ! Open Veg File

	Read (1, *) num_of_veggies    ! Required for Interface

	Do 20 i = 1, index_veggies
	 Read (1,*) planttype, rmin, mintemp, maxtemp, beta, b1, b2,
     /		    psice, sc, rcut, zp, frhgt, frzp,
     /		    rkocap, rccap, rzcap, volini, zstini   ! Read
  20	continue

	close (unit = 1)

      WRITE(11,177) planttype, rmin, mintemp, maxtemp, beta, b1, b2,
     &  psice, sc, rcut, zp, frhgt, frzp, rkocap, rccap, rzcap, volini,
     &  zstini
177   FORMAT(//'   ***  Plant LUT data used for this run  ***'//
     &  'Planttype: 'A/
     &  'RMIN: ',F6.1/
     &  'MINTEMP: ',I6/
     &  'MAXTEMP: ',I6/
     &  'BETA: ',F6.1/
     &  'B1: ',F6.1/
     &  'B2: ',F6.1/
     &  'PSICE: ',F6.1/
     &  'SC: ',F6.1/
     &  'RCUT: ',F6.1/
     &  'ZP: ',F6.1/
     &  'FRHGT: ',F6.1/
     &  'FRZP: ',F6.1/
     &  'RKOCAP: ',F6.1/
     &  'RCCAP: ',F6.1/
     &  'RZCAP: ',F6.1/
     &  'VOLINI: ',F6.1/
     &  'ZSTINI: ',F6.1)

	mintemp = mintemp + 273
	maxtemp = maxtemp + 273

      Endif


 ! Make conversions

      Btemp = btemp + 273.15
      Outtt = outtt * 60
      CO = CO*1E-6
      CI = CI*1E-6


*/ The relevant data for rough.for  08/04/92

*/	If (frveg .eq. 0.0) Class = 'B'
*/	If (frveg .eq. 100) Class = 'V'
*/	If (frveg .lt. 100 .or. frveg .gt. 0.0) Class = 'P'
     
	If (ZO .ne. 0) zo_flag = .true.
	If (Obst_Hgt .ne. 0) ob_flag = .true.

*/ End data

*/ Call the rountine Rough

c	Call RoughCk (class, zo_flag, ob_flag, dual_regime,
c     /		      zo_patch, Obst_Hgt)

	RETURN
	END
